// Win32.cpp
//	Programmed by Piroli YUKARINOMIYA
//	http://www.magicvox.net/

#include "stdafx.h"
#include "Win32.h"
#include <afxinet.h>
#include <Tlhelp32.h>

#ifdef _DEBUG
	#define new DEBUG_NEW
	#undef THIS_FILE
	static char THIS_FILE[] = __FILE__;
#endif

CWinApp theApp;

using namespace std;



static CString strResult =
	"<link href=\"http://www.whatisthatfile.com/design.css\" rel=\"stylesheet\" type=\"text/css\" />\n"
	"<base href=\"http://www.whatisthatfile.com/\">";



static BOOL ExamineProcessName (TCHAR szExeFile[])
{
	cout << "* inquiry " << szExeFile << endl;

	CInternetSession	inetSess (_T("MyTestHTTPClient"));
	INTERNET_PORT		nPort		= INTERNET_DEFAULT_HTTP_PORT;
	LPTSTR				lpszServer	= _T("www.whatisthatfile.com");

	TCHAR				lpszObject [MAX_PATH];
	lstrcpy (lpszObject, _T("api.php?s=table&q="));
	lstrcat (lpszObject, szExeFile);

	// HTTP Requesting
	CHttpConnection *lpHttpConn	= inetSess.GetHttpConnection (lpszServer, nPort);
	if (! lpHttpConn)
	{
		cerr << "\tfailure: GetHttpConnection" << endl;
		return false;
	}

	CHttpFile *lpHttpFile = lpHttpConn->OpenRequest (CHttpConnection::HTTP_VERB_GET, lpszObject);
	if (! lpHttpFile)
	{
		cerr << "\tfailure: OpenRequest" << endl;
		return false;
	}

	if (! lpHttpFile->SendRequest ())
	{
		cerr << "\tfailure: SendRequest" << endl;
		return false;
	}

	DWORD dwStatus;
	if (! lpHttpFile->QueryInfoStatusCode (dwStatus))
	{
		cerr << "\tfailure: QueryInfoStatusCode" << endl;
		return false;
	}
	else if (dwStatus != HTTP_STATUS_OK)
	{
		cerr << "\terror status: " << dwStatus << endl;
		return false;
	} 

	// Retrieve API's Results
	CString	strRes, strBuf;
	while (lpHttpFile->ReadString (strBuf))
		strRes += strBuf;

	// No Rensponce, continue...
	if (! strRes.GetLength ()) {
		cout << "\tNo Responce" << endl;
		return true;
	}

	strResult += "<h1>"; strResult += szExeFile; strResult += "</h1>\n";
	strResult += strRes;

	return true;
}



int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	cout << "* WhatIsThatFile on Win32" << endl << endl;

	// Initializing MFC
	if (! AfxWinInit (::GetModuleHandle (NULL), NULL, ::GetCommandLine (), 0))
	{
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		return EXIT_FAILURE;
	}

	// Process List
	HANDLE hSnap = CreateToolhelp32Snapshot (TH32CS_SNAPPROCESS, 0);
	if ((int) hSnap == -1)
	{
		cerr << "Initialize failure: CreateToolhelp32Snapshot" << endl
			 << "\tProgram terminated" << endl;
		return EXIT_FAILURE;
	}

	PROCESSENTRY32 pe32;
	pe32.dwSize = sizeof (PROCESSENTRY32);

	BOOL loop = Process32First (hSnap, &pe32);
	while (loop)
	{
		if (! ExamineProcessName (pe32.szExeFile))
			break;

		// Sleep for server
		Sleep (1000);

		// next
		loop = Process32Next (hSnap, &pe32);
	}

	// Finalize
	CloseHandle (hSnap);

	// Save as an HTML Page
	LPCTSTR result_file = _T("result.html");
	CFile f;
	f.Open (result_file, CFile::modeCreate | CFile::modeWrite);
	f.Write ((LPCTSTR) strResult, lstrlen (strResult));
	f.Close ();

	// Open the saved file
	ShellExecute (NULL, _T("open"), result_file, NULL, NULL, SW_SHOW);

	return EXIT_SUCCESS;
}
